# -*- coding: utf-8 -*-
"""
Created on Jun 2 2021

@author: Alex
"""
import numpy as np

from pyro.dynamic               import massspringdamper
from pyro.control.linear        import PIDController


# Plant
sys = massspringdamper.ThreeMass( output_mass = 1 )

sys.m1 = 1
sys.m2 = 1
sys.m3 = 1
sys.k1 = 1
sys.k2 = 1
sys.b1 = 0.5
sys.b2 = 0.5

sys.compute_ABCD()

# PID controller
kp  = 1
ki  = 1
kd  = 1

tau = 0.1

ctl = PIDController(kp, ki, kd, tau)

ctl.rbar[0] = 2 # reference

# Simulation Closed-Loop Non-linear with LQR controller
cl_sys = ctl + sys
cl_sys.compute_trajectory( 30 )
cl_sys.plot_trajectory('y')
cl_sys.animate_simulation()